<template>
  <v-card class="pt-4">
    <v-card-text>
      <v-form ref="form" @submit.prevent="validarFormulario">
        <v-select
          v-model="proveedor"
          :items="proveedores"
          item-text="nombre"
          item-value="idproveedores"
          label="Proveedor"
          :rules="rules.nombre"
          required
          color="accent"
        />
      </v-form>
    </v-card-text>

    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
        Cerrar
      </v-btn>
      <v-spacer />
      <v-btn class="elevation-2 font-weight-light accent" @click="validarFormulario">
        Descargar
      </v-btn>
    </v-card-actions>
    <up-web-view v-if="showDialogPDF" :url="urlPDF" @onClose="showDialogPDF=false" />
  </v-card>
</template>

<script lang="ts">
import { Component, Ref, Vue } from 'vue-property-decorator'
import { Proveedor } from '~/core/models/proveedor'
import { ProveedoresStore } from '~/store/ProveedoresStore'
import AppToast from '~/core/utils/AppToast'
import { AppStore } from '~/store/AppStore'
import { App } from '~/core/App'
import UpWebView from '~/components/shared/UpWebView.vue'
@Component({
  components: { UpWebView }
})
export default class formReporteCrítico extends Vue {
  @Ref('form') formulario;

  get proveedores ():Proveedor[] {
    return ProveedoresStore.listaProveedores
  }

  proveedor = null;
  showDialogPDF:boolean = false;
  urlPDF:string = '';

  rules = {
    nombre: [
      v => !!v || 'Campo requerido'
    ]
  };

  cerrarDialog () {
    this.$emit('onClose')
  }

  validarFormulario () {
    if (this.formulario.validate()) {
      this.imprimirStock()
    } else {
      AppToast.error('Campos inválidos')
    }
  }

  imprimirStock () {
    const f = {
      proveedor: this.proveedor
    }

    AppStore.SHOW_LOADING('Descargando datos...')

    const url = 'comprobantes/stock'
    App.$axios.get(url, {
      headers: { Accept: 'application/json' },
      params: f,
      responseType: 'blob'
    }).then((res) => {
      const data: Blob = res.data
      this.urlPDF = window.URL.createObjectURL(data)
      this.showDialogPDF = true
    }).catch(() => {
      AppToast.error('Hubo un error al descargar los datos para imprimir')
    }).finally(() => {
      AppStore.HIDE_LOADING()
    })
  }
}
</script>

<style lang="scss">

</style>
